module PollterGeist
  class ChangeListener
    def initialize
      @previous = []
      @current  = []
      @added    = []
      @removed  = []
    end

    def tick current
      @previous = @current
      @current  = current

      @added    = @current - @previous
      @removed  = @previous - @current
    end

    def added
      @added
    end

    def added?
      !added.empty?
    end

    def removed?
      !removed.empty?
    end

    def changed?
      added? || removed?
    end

    def removed
      @removed
    end
  end
end